/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.gebietsbaum;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.gebietsbaum.boundary.AbstractGebietsartSearchParameters;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartChangeEvent;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartConversationStore;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartSearch;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsart;
import de.ivu.elect.business.gebietsbaum.entity.GebietsartMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractGebietsartSearchView.COMPONENT_NAME)
@View(viewId = AbstractGebietsartSearchView.VIEW_ID, useCase = UseCasePermission.GEBIETSART_SEARCH)
public abstract class AbstractGebietsartSearchView extends AbstractElectSearchView<Gebietsart> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsartSearchView";
  
  public static final String VIEW_ID = "/gebietsbaum/gebietsart-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractGebietsartSearchView requestHandler;

  @Inject
  private transient GebietsartExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(GebietsartConversationStore.class)
  protected transient GebietsartConversationStore conversationStore;

  @Inject
  protected transient GebietsartSearch search;

  @Inject
  @ConversationGroup(AbstractGebietsartSearchParameters.class)
  protected transient GebietsartSearchParameters searchParameters;

  @Inject
  protected transient GebietsartMeta entityMeta;

  public AbstractGebietsartSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Gebietsart getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Gebietsart entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public GebietsartSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Gebietsart> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Gebietsart> create();
  }

  @Override
  public List<Gebietsart> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Gebietsart> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onGebietsartChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietsartChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractGebietsartSearchView {

    @View
    @Inject
    private transient Instance<AbstractGebietsartSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractGebietsartSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
